// Elliot K. Canfield-Dafilou (kermitATccrma.stanford.edu)
// March, 2017
// This work is licensed under the Creative Commons Attribution 4.0 International License.

(
// load one bell
~path = "bell10.csv";      // change this
~data = CSVFileReader.read(~path);
~freqs = Array.newClear(~data.size);
~amps = Array.newClear(~data.size);
~taus = Array.newClear(~data.size);
~phases = Array.newClear(~data.size);
~data.size.do({|i|
	~freqs[i] = ~data[i][0].asFloat;
	~amps[i] = ~data[i][1].asFloat;
	~taus[i] = ~data[i][2].asFloat;
    ~phases[i] = ~data[i][3].asFloat;
});

// ~freqs, ~amps, ~taus, and ~phases now hold the modal parameters for one bell


s.waitForBoot({
	// this synthdef defines a signel partial (one freq, decay, amp, phase, and output channel
	SynthDef(\partial, {|freq, amp, decay, phase=0, chan=0|
        var sig = amp * SinOsc.ar(freq, phase) * Decay2.ar(Impulse.ar(0), 0.001, decay);
        DetectSilence.ar(sig, doneAction:2);
		Out.ar(chan, sig);
	}).add;

	// for this demo, this prevents us from trying to use the synth too early
	{0.5.wait}.defer;

	// synthesize the first 30 (or total number of) partials
	~numPartials = min(30, ~amps.size);
	~numPartials.do({|i|
		Synth(\partial, [\freq, ~freqs[i], \amp, ~amps[i], \decay, 6.9*~taus[i], \phase, ~phases[i]]);
	});

});
);
